% UNIVERSIDAD NACIONAL DE MAR DEL PLATA
% FACULTAD DE INGENIERIA - DTO ELECTRONICA
% LABORATORIO INSTRUMENTACION Y CONTROL
% CATEDRA: TEORIA DE CONTROL

%% GUIA- ESTIMADOR DE ESTADOS
% EJERCICIO: 8.3
close all;
clc;
% VALORES CORRESPONDIENTES AL EJERCICIO DE LA CINTA
% -------------------------------------------------
% PARAMETROS DEL MOTOR
Ra=2.4;   %[Ohms]
La=0.04;  %[Hy]
Kt=0.86;  %[N m/A]
Kw=1.07;  %[V s/rad]

% PARAMETROS DE LA CARGA MECANICA
B1=0.04;  %[N s/rad]
B2=2;     %[N s/m]
J =0.025; %[N m s^2]
K =500;   %[N/m]

% PARAMETROS DE LAS POLEAS
r1=0.1;   %[m]
r2=0.1;   %[m]
A0 =10;
Kp=1;

% -------------------------------------------------
% MODELO DE ESTADOS CONTINUO
A=[-Ra/La -Kw/La 0; Kt/J -B1/J -K*r1/(2*J); 0 r1/2 -K/(4*B2)];
B=[A0/La; 0; 0];
C=[0 0 K/2];  % Salida fuerza sobre la lamina
D=0;
P1=ss(A,B,C,D);

% Modifico la matriz C para salir con el resto de
% las variables de estado
% P1.c=[1 0 0; 0 1 0;C];
% P1.d=[0;0;0];

% MODELO DE ESTADOS DISCRETO
Ts=0.01;
P2=c2d(P1,Ts);

% MODELO CANONICO OBSERVABLE
[num,den]=tfdata(P2,'v');
Ac=[0,1,0;0,0,1;-den(4),-den(3),-den(2)];
Bc=[0;0;1];
Cc=[num(4),num(3),num(2)];
Dc=0;
P4=transpose(ss(Ac,Bc,Cc,Dc,0.01));

% OBSERVABILIDAD DE LOS MODELOS Y MATRIZ DE TRANSFORMACION
V1=obsv(P2);  % Observabilidad planta original
V2=obsv(P4);  % Observabilidad modelo canonico
Q=inv(V1)*V2; % Matriz de transformacion al modelo canonico

% ESTIMADOR DE ESTADOS
% Autovalores del estimador
z1=input('Ingrese el autovalor del estimador z1 = ');
z2=input('Ingrese el autovalor del estimador z2 = ');
z3=input('Ingrese el autovalor del estimador z3 = ');

H1=acker(Ac,Bc,[z1,z2,z3])'; % Vector del Estimador del Modelo Canonico
H2=Q*H1; % Vector del Estimador transformado

% Matrices del estimador
Ae=(P2.a-H2*P2.c);
eig(Ae);
Be=[P2.b H2];
Ce=eye(3);

x01=input('Ingrese condicion inicial del estimador para coriente del motor x01 = ');
x02=input('Ingrese condicion inicial del estimador para velocidad del motor x02 = ');
x03=input('Ingrese condicion inicial del estimador para fuerza sobre la lamina x03 = ');
Xe0=[x01,x02,x03];
De=zeros(3,2);

Ia0=input('Ingrese condicion inicial de la planta Ia0 = ');
w0=input('Ingrese condicion inicial de la planta w0 = ');
x0=input('Ingrese condicion inicial de la planta x0 =  ');


% -------------------------------------------------
% REALIMENTACIN DE ESTADOS

Psi=1;
Tss=2;  % seg
p1=3/Psi/Tss;
p2=3/Psi/Tss;
p3=30/Psi/Tss;

p1d=exp(-p1*Ts);
p2d=exp(-p2*Ts);
p3d=exp(-p3*Ts);

% VECTOR DE REALIMENTACION
Ktr=acker(P2.a,P2.b, [p1d, p2d, p3d]);

% MODELO DE LAZO CERRADO
P3=P2;
P3.a=P2.a-P2.b*Ktr;
Ai=dcgain(P3);

%Ai=input('Ingrese ganancia deseada a lazo cerrado Ai =');
